unit uadvdmxheader;

interface

const
  dllfile = 'advdmx.dll';

function  parInit: Boolean; cdecl; external dllfile;
procedure parFinish; cdecl; external dllfile;
function resync(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 256 writes.
}
function reset(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function clearAll(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function clearInput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function clearOutput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function defaults(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function setBreakTime(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function setMabTime(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function setOutputCount(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function setMuxAddress(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function enableInputWildcard(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function disableInputWildcard(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function setInputStartcode(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function enableInput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function disableInput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function enableOutput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function disableOutput(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function getInputStartcode(port: Word; var inputStartcode: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function getInputCount(port: Word; var inputCount: SmallInt): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function getTimeSinceInput(port: Word; var timeSinceInput: Word): Boolean; cdecl; external dllfile;
{
  Uses 4 writes.
  In order to convert value to seconds, it must be multiplied by 0.000128.
}
function getMuxValue(port: Word; var muxValue: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function input(port: Word; channel: Byte; var value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 3 writes.
  1 input call takes about 0,090 ms.
}
function bulkInput(port: Word; channels: array of Byte; var values: array of Byte): Boolean; cdecl; external dllfile;
{
  Uses 1 + (number of requested input channels * 2) + 1 writes.
}
function setOutputStartcode(port: Word; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 2 writes.
}
function output(port: Word; channel: Byte; value: Byte): Boolean; cdecl; external dllfile;
{
  Uses 3 writes.
}
function bulkOutput(port: Word; channels: array of Byte; values: array of Byte): Boolean; cdecl; external dllfile;
{
  Uses 1 + (number of requested output channels * 2) + 1 writes.
}
function setMassOutputLimits(port: Word; minChannel, maxChannel: Byte): Boolean; cdecl; external dllfile;
{
  Uses 3 writes.
}
function massOutput(port: Word; values: array of Byte): Boolean; cdecl; external dllfile;
{
  Uses 1 + (number of configured mass output channels) writes.
}
function enableMux(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function disableMux(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function forceMuxOff(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function noForceMuxOff(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function invertedMux(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function nonInvertedMux(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function enableMerge(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function disableMerge(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function finish(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function readEEPROM(port: Word): Boolean; cdecl; external dllfile;
{
  Uses 1 write.
}
function writeEEPROM(port: Word; inputEnabled, outputEnabled, muxEnabled, mergeEnabled: Boolean): Boolean; cdecl; external dllfile;
{
  Uses 5 writes.
}
function echo(port: Word; echoRequest: Byte; var echoResult: Byte): Boolean; cdecl; external dllfile;
{
  Uses 3 writes.
}

implementation

end.
