unit uparport;

interface

const
  DATA = 0;
  D7   = 128;
  D6   = 64;
  D5   = 32;
  D4   = 16;
  D3   = 8;
  D2   = 4;
  D1   = 2;
  D0   = 1;

  STATUS = 1;
  BUSY   = 128; // laag indien actief
  ACK    = 64;
  PE     = 32;
  SEL    = 16;
  ERR    = 8;

  CONTROL = 2;
  SELIN   = 8;
  RESET   = 4;
  LF      = 2;
  STR     = 1; // hoog indien actief

function  parInit(): Boolean; cdecl;
procedure parFinish(); cdecl;
function  parIn(port: Word): Byte; assembler;
procedure parOut(port: Word; value: Byte); assembler;

implementation

uses
  usmallport;

var
  bSmallPort: TSmallPort;

function parInit(): Boolean;
begin
  bSmallPort := TSmallPort.Create(nil);
  bSmallPort.OpenDriver();
  Result := bSmallPort.IsOpen();
end;

procedure parFinish();
begin
  bSmallPort.CloseDriver;
  bSmallPort.Free;
end;

function  parIn(port: Word): Byte;
begin
  if bSmallPort.IsOpen() then
    Result := bSmallPort.Port[port]
  else
    Result := 0;
end;

procedure parOut(port: Word; value: Byte);
begin
  if bSmallPort.IsOpen then
    bSmallPort.Port[port] := value;
end;

end.
