unit upartest;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, unitportdetect;

const
  nInputs  = 245; // excluding start code
  nOutputs = 255; // excluding start code

type
  TfParTest = class(TForm)
    tRefresh: TTimer;
    pcFeatures: TPageControl;
    tsInput: TTabSheet;
    gInput: TGroupBox;
    lGetTimeSinceInput: TLabel;
    bEnableInput: TButton;
    bDisableInput: TButton;
    bInputStartcode: TButton;
    eInputStartcode: TEdit;
    bGetInputCount: TButton;
    eGetInputCount: TEdit;
    bGetTimeSinceInput: TButton;
    eGetTimeSinceInput: TEdit;
    pbGetTimeSinceInput: TProgressBar;
    chGetTimeSinceInput: TCheckBox;
    chGetInputCount: TCheckBox;
    bEnableWildcard: TButton;
    bDisableWildcard: TButton;
    tsOutput: TTabSheet;
    gOutput: TGroupBox;
    bBreakTime: TButton;
    eBreakTime: TEdit;
    bMabTime: TButton;
    eMabTime: TEdit;
    bOutputCount: TButton;
    eOutputCount: TEdit;
    bEnableOutput: TButton;
    bDisableOutput: TButton;
    tsMultiplexer: TTabSheet;
    gMux: TGroupBox;
    bEnableMux: TButton;
    bDisableMux: TButton;
    bMuxAddress: TButton;
    eMuxAddress: TEdit;
    bInvertedMux: TButton;
    bNonInvertedMux: TButton;
    tsMerge: TTabSheet;
    gMerge: TGroupBox;
    bEnableMerge: TButton;
    bDisableMerge: TButton;
    tsEEPROM: TTabSheet;
    gEEPROM: TGroupBox;
    chEnableInput: TCheckBox;
    bWriteEEPROM: TButton;
    chEnableOutput: TCheckBox;
    chEnableMux: TCheckBox;
    chEnableMerge: TCheckBox;
    tsBasic: TTabSheet;
    gBasic: TGroupBox;
    bResync: TButton;
    bReset: TButton;
    bFinish: TButton;
    bClearAll: TButton;
    bClearInput: TButton;
    bClearOutput: TButton;
    lPort: TLabel;
    cbPort: TComboBox;
    lPortNumber: TLabel;
    gParallelOutput: TGroupBox;
    chD0: TCheckBox;
    chSTR: TCheckBox;
    chD1: TCheckBox;
    chD2: TCheckBox;
    chD3: TCheckBox;
    chD4: TCheckBox;
    chD5: TCheckBox;
    chD6: TCheckBox;
    chD7: TCheckBox;
    eDATA: TEdit;
    lDATA: TLabel;
    gbParallelInput: TGroupBox;
    chACK: TCheckBox;
    chPE: TCheckBox;
    chSEL: TCheckBox;
    chERR: TCheckBox;
    chBUSY: TCheckBox;
    bRefresh: TButton;
    chRefresh: TCheckBox;
    bGetInputStartcode: TButton;
    eGetInputStartcode: TEdit;
    chGetInputStartcode: TCheckBox;
    bOutputStartcode: TButton;
    eOutputStartcode: TEdit;
    tsInOut: TTabSheet;
    gInOut: TGroupBox;
    bInputAll: TButton;
    chInputAll: TCheckBox;
    bOutputSingle: TButton;
    eOutputSingleChannel: TEdit;
    eOutputSingleValue: TEdit;
    bOutputAll: TButton;
    bInputSingle: TButton;
    eInputSingleChannel: TEdit;
    eInputSingleValue: TEdit;
    bMassOutput: TButton;
    eMassOutputFirstChannel: TEdit;
    eMassOutputLastChannel: TEdit;
    chSELIN: TCheckBox;
    chRESET: TCheckBox;
    chLF: TCheckBox;
    bForceMuxOff: TButton;
    bNoForceMuxOff: TButton;
    bGetMuxValue: TButton;
    eGetMuxValue: TEdit;
    chGetMuxValue: TCheckBox;
    lGetMuxValue: TLabel;
    bReadEEPROM: TButton;
    bDefaults: TButton;
    bEEPROMHelper: TButton;
    bEcho: TButton;
    eEcho2: TEdit;
    eEcho: TEdit;
    lBenchmark2: TLabel;
    lBenchmark: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cbPortChange(Sender: TObject);
    procedure chDATAClick(Sender: TObject);
    procedure eDATAChange(Sender: TObject);
    procedure chSELINClick(Sender: TObject);
    procedure chRESETClick(Sender: TObject);
    procedure chLFClick(Sender: TObject);
    procedure chSTRClick(Sender: TObject);
    procedure bRefreshClick(Sender: TObject);
    procedure benchmarkStart;
    procedure benchmarkStop;
    procedure bResyncClick(Sender: TObject);
    procedure bFinishClick(Sender: TObject);
    procedure bResetClick(Sender: TObject);
    procedure bDefaultsClick(Sender: TObject);
    procedure bClearAllClick(Sender: TObject);
    procedure bClearInputClick(Sender: TObject);
    procedure bClearOutputClick(Sender: TObject);
    procedure bEchoClick(Sender: TObject);
    procedure bInputSingleClick(Sender: TObject);
    procedure bInputAllClick(Sender: TObject);
    procedure bOutputSingleClick(Sender: TObject);
    procedure bOutputAllClick(Sender: TObject);
    procedure bMassOutputClick(Sender: TObject);
    procedure bEnableInputClick(Sender: TObject);
    procedure bDisableInputClick(Sender: TObject);
    procedure bInputStartcodeClick(Sender: TObject);
    procedure bEnableWildcardClick(Sender: TObject);
    procedure bDisableWildcardClick(Sender: TObject);
    procedure bGetInputStartcodeClick(Sender: TObject);
    procedure bGetInputCountClick(Sender: TObject);
    procedure bGetTimeSinceInputClick(Sender: TObject);
    procedure bEnableOutputClick(Sender: TObject);
    procedure bDisableOutputClick(Sender: TObject);
    procedure bBreakTimeClick(Sender: TObject);
    procedure bMabTimeClick(Sender: TObject);
    procedure bOutputStartcodeClick(Sender: TObject);
    procedure bOutputCountClick(Sender: TObject);
    procedure bEnableMuxClick(Sender: TObject);
    procedure bDisableMuxClick(Sender: TObject);
    procedure bInvertedMuxClick(Sender: TObject);
    procedure bNonInvertedMuxClick(Sender: TObject);
    procedure bMuxAddressClick(Sender: TObject);
    procedure bForceMuxOffClick(Sender: TObject);
    procedure bNoForceMuxOffClick(Sender: TObject);
    procedure bGetMuxValueClick(Sender: TObject);
    procedure bEnableMergeClick(Sender: TObject);
    procedure bDisableMergeClick(Sender: TObject);
    procedure bWriteEEPROMClick(Sender: TObject);
    procedure bReadEEPROMClick(Sender: TObject);
    procedure bEEPROMHelperClick(Sender: TObject);
    procedure tRefreshTimer(Sender: TObject);
  private
    { Private declarations }
    eInput:  array[0..nInputs - 1] of TEdit;
    eOutput: array[0..nOutputs - 1] of TEdit;
    lptPorts: array[0..2] of TDetectedPort;
    BASE:    Word;
    time:    Int64;
    procedure outputData;
  public
    { Public declarations }
  end;

var
  fParTest: TfParTest;

implementation

{$R *.dfm}

uses
  uparport, uadvdmx, ueepromhelper;

var
  currentInput: Byte = 0;
  tickFreq: Int64 = 0;

procedure tickInit;
begin
  QueryPerformanceFrequency(tickFreq);
end;

function  tickCount: Int64;
var
  ticks: Int64;
begin
  if tickFreq > 0 then
  begin
    if QueryPerformanceCounter(ticks) then
      Result := Round(ticks / (tickFreq / 1000))
    else
    begin
      tickFreq := 0;
      Result   := GetTickCount;
    end;
  end
  else
    Result := GetTickCount;
end;

procedure TfParTest.FormCreate(Sender: TObject);
const
  fontName = 'Verdana';
  fontSize = 8;
  boxWidth = 30;
  boxesPerRow = 26;
  rowSpacing = 40;
  boxSpacing = 30;
var
  i: Byte;
begin
  getLPTPorts(lptPorts);
  for i := 0 to 2 do
    if lptPorts[i].portLength > 0 then
      cbPort.Items.Add(lptPorts[i].friendlyName);
  BASE := lptPorts[0].portStart;
  cbPort.ItemIndex := 0;
  tickInit();
  for i := 0 to nInputs - 1 do
  begin
    eInput[i] := TEdit.Create(Self);
    with eInput[i] do
    begin
      Top        := 4 + (i div boxesPerRow) * rowSpacing;
      Left       := 4 + (i mod boxesPerRow) * boxSpacing;
      Width      := boxWidth;
      Font.Name  := fontName;
      Font.Size  := fontSize;
      Font.Color := clGreen;
      Font.Style := Font.Style + [fsBold];
      Text       := '';
      Hint       := 'Input channel ' + IntToStr(i + 1);
      ShowHint   := True;
      ReadOnly   := True;
      Parent     := Self;
    end;
  end;
  for i := 0 to nOutputs - 1 do
  begin
    eOutput[i] := TEdit.Create(Self);
    with eOutput[i] do
    begin
      Top        := 23 + (i div boxesPerRow) * rowSpacing;
      Left       := 4 + (i mod boxesPerRow) * boxSpacing;
      Width      := boxWidth;
      Font.Name  := fontName;
      Font.Size  := fontSize;
      Font.Color := $000080FF;
      Font.Style := Font.Style + [fsBold];
      Text       := '255';//'50';
      Hint       := 'Output channel ' + IntToStr(i + 1);
      ShowHint   := True;
      MaxLength  := 3;
      Parent     := Self;
    end;
  end;
  if parInit() then
  begin
    chSTR.Checked := parIn(BASE + CONTROL) and STR = STR;
    chD7.Checked  := parIn(BASE + DATA) and D7 = D7;
    chD6.Checked  := parIn(BASE + DATA) and D6 = D6;
    chD5.Checked  := parIn(BASE + DATA) and D5 = D5;
    chD4.Checked  := parIn(BASE + DATA) and D4 = D4;
    chD3.Checked  := parIn(BASE + DATA) and D3 = D3;
    chD2.Checked  := parIn(BASE + DATA) and D2 = D2;
    chD1.Checked  := parIn(BASE + DATA) and D1 = D1;
    chD0.Checked  := parIn(BASE + DATA) and D0 = D0;

    if cbPort.Items.Count > 0 then
      cbPortChange(Sender)
    else
    begin
      MessageBox(Handle, 'There are no parallel ports available!'#13#10'The interface tester will close.', PChar(Caption), MB_ICONERROR);
      Application.Terminate;
    end;
  end
  else
  begin
    MessageBox(Handle, 'Parallel port initialization error!'#13#10'The interface tester will close.', PChar(Caption), MB_ICONERROR);
    Application.Terminate();
  end;
end;

procedure TfParTest.FormDestroy(Sender: TObject);
var
  i: Integer;
begin
  parFinish();
  for i := 0 to nInputs - 1 do
    eInput[i].Free;
  for i := 0 to nOutputs - 1 do
    eOutput[i].Free;
end;

procedure TfParTest.cbPortChange(Sender: TObject);
var
  port: Word;
begin
  port := lptPorts[cbPort.ItemIndex].portStart;
  BASE := port;
  lPortNumber.Caption := '(0x' + IntToHex(port, 4) + ')';

  chD7.Checked    := parIn(BASE + DATA)    and D7    = D7;
  chD6.Checked    := parIn(BASE + DATA)    and D6    = D6;
  chD5.Checked    := parIn(BASE + DATA)    and D5    = D5;
  chD4.Checked    := parIn(BASE + DATA)    and D4    = D4;
  chD3.Checked    := parIn(BASE + DATA)    and D3    = D3;
  chD2.Checked    := parIn(BASE + DATA)    and D2    = D2;
  chD1.Checked    := parIn(BASE + DATA)    and D1    = D1;
  chD0.Checked    := parIn(BASE + DATA)    and D0    = D0;
  chSELIN.Checked := parIn(BASE + CONTROL) and SELIN = SELIN;
  chRESET.Checked := parIn(BASE + CONTROL) and uparport.RESET = uparport.RESET;
  chLF.Checked    := parIn(BASE + CONTROL) and LF    = LF;
  chSTR.Checked   := parIn(BASE + CONTROL) and STR   = STR;
end;

procedure TfParTest.outputData;
var
  d: Byte;
begin
  d := parIn(BASE + DATA);
  if chD7.Checked then
    d := d or D7
  else
    d := d and not(D7);
  if chD6.Checked then
    d := d or D6
  else
    d := d and not(D6);
  if chD5.Checked then
    d := d or D5
  else
    d := d and not(D5);
  if chD4.Checked then
    d := d or D4
  else
    d := d and not(D4);
  if chD3.Checked then
    d := d or D3
  else
    d := d and not(D3);
  if chD2.Checked then
    d := d or D2
  else
    d := d and not(D2);
  if chD1.Checked then
    d := d or D1
  else
    d := d and not(D1);
  if chD0.Checked then
    d := d or D0
  else
    d := d and not(D0);
  parOut(BASE + DATA, d)
end;

procedure TfParTest.chDATAClick(Sender: TObject);
begin
  outputData;
end;

procedure TfParTest.eDATAChange(Sender: TObject);
var
  c: Byte;
begin
  if eDATA.Text <> '' then
  begin
    c := Ord(eDATA.Text[1]);
    chD7.Checked := c and D7 = D7;
    chD6.Checked := c and D6 = D6;
    chD5.Checked := c and D5 = D5;
    chD4.Checked := c and D4 = D4;
    chD3.Checked := c and D3 = D3;
    chD2.Checked := c and D2 = D2;
    chD1.Checked := c and D1 = D1;
    chD0.Checked := c and D0 = D0;
    outputData;
  end;
end;

procedure TfParTest.chSELINClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) or SELIN)
  else
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) and not(SELIN));
end;

procedure TfParTest.chRESETClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) or uparport.RESET)
  else
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) and not(uparport.RESET));
end;

procedure TfParTest.chLFClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) or LF)
  else
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) and not(LF));
end;

procedure TfParTest.chSTRClick(Sender: TObject);
begin
  if (Sender as TCheckBox).Checked then
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) or STR)
  else
    parOut(BASE + CONTROL,parIn(BASE + CONTROL) and not(STR));
end;

procedure TfParTest.bRefreshClick(Sender: TObject);
begin
  chBUSY.Checked  := parIn(BASE + STATUS)  and BUSY = BUSY;
  chACK.Checked   := parIn(BASE + STATUS)  and ACK  = ACK;
  chPE.Checked    := parIn(BASE + STATUS)  and PE   = PE;
  chSEL.Checked   := parIn(BASE + STATUS)  and SEL  = SEL;
  chERR.Checked   := parIn(BASE + STATUS)  and ERR  = ERR;
end;

procedure TfParTest.benchmarkStart;
begin
  Screen.Cursor := crHourglass;
  time := tickCount;
end;

procedure TfParTest.benchmarkStop;
begin
  lBenchmark2.Caption := IntToStr(tickCount - Time);
  Screen.Cursor := crDefault;
end;

// basic tab

procedure TfParTest.bResyncClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(resync(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bFinishClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(finish(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bResetClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(reset(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDefaultsClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(defaults(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bClearAllClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to nOutputs - 1 do
    eOutput[i].Text := '0';
  benchmarkStart();
  try
    if not(clearAll(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop();
  end;
end;

procedure TfParTest.bClearInputClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(clearInput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bClearOutputClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to nOutputs - 1 do
    eOutput[i].Text := '0';
  benchmarkStart();
  try
    if not(clearOutput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop();
  end;
end;

procedure TfParTest.bEchoClick(Sender: TObject);
var
  echoResult: Byte;
begin
  if eEcho.Text <> '' then
  begin
    benchmarkStart;
    try
      if not(echo(BASE, Ord(eEcho.Text[1]), echoResult)) then
        ShowMessage('Error');
    finally
      benchmarkStop;
    end;
    eEcho2.Text := Chr(echoResult);
  end
  else
    eEcho2.Text := 'ERR';
end;

// I/O tab

procedure TfParTest.bInputSingleClick(Sender: TObject);
var
  c, v: Byte;
begin
  c := StrToIntDef(eInputSingleChannel.Text, 0);
  benchMarkStart;
  try
    if not(input(BASE, c, v)) then
      ShowMessage('Error');
  finally
    benchMarkStop;
  end;
  eInputSingleValue.Text := IntToStr(v);
end;

procedure TfParTest.bInputAllClick(Sender: TObject);
var
  i: Byte;
  c, a: array[0..nInputs - 1] of Byte;
begin
  for i := 0 to nInputs - 1 do
    c[i] := i;
  benchmarkStart;
  try
    if not(bulkInput(BASE, c, a)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
  for i := 0 to nInputs - 1 do
    eInput[i].Text := IntToStr(a[i]);
end;

procedure TfParTest.bOutputSingleClick(Sender: TObject);
var
  c, v: Byte;
begin
  c := StrToIntDef(eOutputSingleChannel.Text, 0);
  v := StrToIntDef(eOutputSingleValue.Text, 0);
  benchmarkStart;
  try
    if not(output(BASE, c, v)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bOutputAllClick(Sender: TObject);
var
  i: Byte;
  c: array[0..nOutputs - 1] of Byte;
  a: array[0..nOutputs - 1] of Byte;
begin
  for i := 0 to nOutputs - 1 do
    c[i] := i;
  for i := 0 to nOutputs - 1 do
    a[i] := StrToIntDef(eOutput[i].Text, 0);
  benchmarkStart;
  try
    if not(bulkOutput(BASE, c, a)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bMassOutputClick(Sender: TObject);
var
  f, l, i: Byte;
  a: array of Byte;
begin
  f := StrToIntDef(eMassOutputFirstChannel.Text, 0);
  l := StrToIntDef(eMassOutputLastChannel.Text, nOutputs - 1);
  SetLength(a, l - f + 1);
  benchmarkStart;
  try
    setMassOutputLimits(BASE, f, l);
    for i := f to l do
      a[i - f] := StrToIntDef(eOutput[i].Text, 0);
    if not(massOutput(BASE, a)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

// Input tab

procedure TfParTest.bEnableInputClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(enableInput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDisableInputClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(disableInput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop
  end;
end;

procedure TfParTest.bInputStartcodeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setInputStartcode(BASE, StrToInt(eInputStartcode.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bEnableWildcardClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(enableInputWildcard(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDisableWildcardClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(disableInputWildcard(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bGetInputStartcodeClick(Sender: TObject);
var
  inputStartcode: Byte;
begin
  benchmarkStart;
  try
    if not(getInputStartcode(BASE, inputStartcode)) then
      ShowMessage('Error')
    else
      eGetInputStartcode.Text := IntToStr(inputStartcode);
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bGetInputCountClick(Sender: TObject);
var
  inputCount: SmallInt;
begin
  benchmarkStart;
  try
    if not(getInputCount(BASE, inputCount)) then
      ShowMessage('Error')
    else
      eGetInputCount.Text := IntToStr(inputCount);
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bGetTimeSinceInputClick(Sender: TObject);
var
  timeSinceInput: Word;
begin
  benchmarkStart;
  try
    if not(getTimeSinceInput(BASE, timeSinceInput)) then
      ShowMessage('Error')
    else
    begin
      eGetTimeSinceInput.Text := IntToStr(timeSinceInput);
      pbGetTimeSinceInput.Position := timeSinceInput;
      lGetTimeSinceInput.Caption := FloatToStr(timeSinceInput * 0.000128) + ' seconds';
    end;
  finally
    benchmarkStop;
  end;
end;

// output tab

procedure TfParTest.bEnableOutputClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(enableOutput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDisableOutputClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(disableOutput(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bBreakTimeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setBreakTime(BASE, StrToInt(eBreakTime.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bMabTimeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setMabTime(BASE, StrToInt(eMabTime.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bOutputStartcodeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setOutputStartcode(BASE, StrToInt(eOutputStartcode.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bOutputCountClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setOutputCount(BASE, StrToInt(eOutputCount.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

// multiplexer tab

procedure TfParTest.bEnableMuxClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(enableMux(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDisableMuxClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(disableMux(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bInvertedMuxClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(invertedMux(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bNonInvertedMuxClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(nonInvertedMux(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bMuxAddressClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(setMuxAddress(BASE, StrToInt(eMuxAddress.Text))) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bForceMuxOffClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(forceMuxOff(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bNoForceMuxOffClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(noForceMuxOff(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bGetMuxValueClick(Sender: TObject);
var
  muxValue: Byte;
begin
  benchmarkStart;
  try
    if not(getMuxValue(BASE, muxValue)) then
      ShowMessage('Error')
    else
    begin
      eGetMuxValue.Text := IntToStr(muxValue);
      lGetMuxValue.Caption :=
        IntToStr(Ord(muxValue and 128 = 128)) +
        IntToStr(Ord(muxValue and 64 = 64)) +
        IntToStr(Ord(muxValue and 32 = 32)) +
        IntToStr(Ord(muxValue and 16 = 16)) +
        IntToStr(Ord(muxValue and 8 = 8)) +
        IntToStr(Ord(muxValue and 4 = 4)) +
        IntToStr(Ord(muxValue and 2 = 2)) +
        IntToStr(Ord(muxValue and 1 = 1));
    end;
  finally
    benchmarkStop;
  end;
end;

// merge tab

procedure TfParTest.bEnableMergeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(enableMerge(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bDisableMergeClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(disableMerge(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

// EEPROM tab

procedure TfParTest.bWriteEEPROMClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(writeEEPROM(BASE, chEnableInput.Checked, chEnableOutput.Checked, chEnableMux.Checked, chEnableMerge.Checked)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
  // delay so that EEPROM write will finish before this event handler will be left
  Sleep(4000);
end;

procedure TfParTest.bReadEEPROMClick(Sender: TObject);
begin
  benchmarkStart;
  try
    if not(readEEPROM(BASE)) then
      ShowMessage('Error');
  finally
    benchmarkStop;
  end;
end;

procedure TfParTest.bEEPROMHelperClick(Sender: TObject);
begin
  fEEPROMHelper.ShowModal;
end;

procedure TfParTest.tRefreshTimer(Sender: TObject);
begin
  if chRefresh.Checked then
    bRefreshClick(Sender);
  if chInputAll.Checked then
    bInputAllClick(Sender);
  if chGetInputStartcode.Checked then
    bGetInputStartcodeClick(Sender);
  if chGetInputCount.Checked then
    bGetInputCountClick(Sender);
  if chGetTimeSinceInput.Checked then
    bGetTimeSinceInputClick(Sender);
  if chGetMuxValue.Checked then
    bGetMuxValueClick(Sender);
end;

end.
